/*-----------------------------------------------------------------------+
| Doom Runner: A cross-platform GUI frontend for Doom.                   |
| Copyright (C) 2011 Nick Virag                                          |
+------------------------------------------------------------------------+
| This program is free software: you can redistribute it and/or modify   |
| it under the terms of the GNU General Public License as published by   |
| the Free Software Foundation, either version 3 of the License, or      |
| any later version.                                                     |
+------------------------------------------------------------------------+
| This program is distributed in the hope that it will be useful,        |
| but WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
| GNU General Public License for more details.                           |
+------------------------------------------------------------------------+
| You should have received a copy of the GNU General Public License      |
| along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
+------------------------------------------------------------------------+
| Contact Nick Virag at: <nick@win31.net>, <support@retronuggetdev.com>, |
| or <nickel516@gmail.com>.                                              |
+-----------------------------------------------------------------------*/
#ifndef CONFIG_H
#define	CONFIG_H
#include <QtGui/QWidget>
#include <QtGui/QTabWidget>
#include <QtGui/QRadioButton>
#include <QtGui/QGraphicsView>
#include <QtGui/QGraphicsScene>
#include <QtGui/QPushButton>
#include <QtGui/QComboBox>
#include <QtGui/QCheckBox>
#include <QtGui/QLineEdit>
#include <QtGui/QLabel>
#include <QtGui/QSlider>
#include <QtGui/QListWidget>

class QGaphicsView;
class QTabBar;
class QRadioButton;
class QGraphicsScene;
class QPushButton;
class QComboBox;
class QCheckBox;
class QLineEdit;
class QLabel;
class QSlider;
class QListWidget;
class entrywindow;
class editprofile : public QWidget

{

    Q_OBJECT

public:
    editprofile ();

    signals:
    void signalemit ();

public slots:
    void addfilebutton ();
    void radioselect1 ();
    void customimageaddbutton ();
    void changeresolutionselect ();
    void bitselected ();
    void glselected ();
    void arrangeresolutionset ();
    void navbarselect ();
    void autobuttondisplay ();
    void exebuttonselect ();
    void writeprofile ();
    void cancelbutton ();
    void fileselect ();
    void glfileselect ();
    void moveconfigwindow ();
    void styleselectslot ();
    void slideeffectshowhide ();
    void buttonhelpclicked ();
    void buttonmoveup ();
    void buttonmovedown ();
    void buttonremove ();
	void buttonremoveiwad ();

private:
    QWidget *editgame;
    QTabWidget *editnavbar;
    QRadioButton *radio1;
    QRadioButton *radio2;
    QGraphicsView *profileimage;
    QGraphicsScene *loadimage;
    QPushButton *customimageadd;
    QComboBox *iwadselect;
    QWidget *editav;
    QRadioButton *edits;
    QRadioButton *editno;
    QComboBox *displayselect;
    QComboBox *resolutionselect;
    QGraphicsView *displayimage;
    QGraphicsScene *loaddisplayimage;
    QPushButton *buttonautoset;
    QCheckBox *editsm;
    QCheckBox *editm;
    QWidget *advancededit;
    QComboBox *newportselect;
    QPushButton *regexe;
    QPushButton *glexe;
    QCheckBox *joysticktoggle;
    QLineEdit *cmdparamsedit;
    QLineEdit *profiletitle;
    QLineEdit *profilenotesedit;
    QCheckBox *monstertoggle;
    QString imagedata;
    QString filename;
    QLabel *qlexecutable;
    QLabel *qlglexecutable;
    QWidget *doomrunneredit;
    QComboBox *styleselect;
    QLabel *styleselecttext;
    QLabel *styleselectdescription;
    QCheckBox *slideeffecttoggle;
    QSlider *slideeffectvalue;
    QLabel *slideeffecttext;
    QCheckBox *nativemenubar;
    QListWidget *pwadselectlist;
    QListWidget *dehselectlist;
    QPushButton *filemoveup;
    QPushButton *filemovedown;
    QPushButton *filedelete;
	QPushButton *removeiwad;
};

#endif
