/*-----------------------------------------------------------------------+
| Doom Runner: A cross-platform GUI frontend for Doom.                   |
| Copyright (C) 2011 Nick Virag                                          |
+------------------------------------------------------------------------+
| This program is free software: you can redistribute it and/or modify   |
| it under the terms of the GNU General Public License as published by   |
| the Free Software Foundation, either version 3 of the License, or      |
| any later version.                                                     |
+------------------------------------------------------------------------+
| This program is distributed in the hope that it will be useful,        |
| but WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
| GNU General Public License for more details.                           |
+------------------------------------------------------------------------+
| You should have received a copy of the GNU General Public License      |
| along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
+------------------------------------------------------------------------+
| Contact Nick Virag at: <nick@win31.net>, <support@retronuggetdev.com>, |
| or <nickel516@gmail.com>.                                              |
+-----------------------------------------------------------------------*/
#ifndef DOOMRUNNER_H
#define	DOOMRUNNER_H
#include <QtGui/QMainWindow>
#include <QtGui/QWidget>
#include <QtGui/QListWidget>
#include <QtGui/QListWidgetItem>

class QAction;
class QGraphicsScene;
class QListWidget;
class QListWidgetItem;
class QGraphicsView;
class QLabel;
class QSpacerItem;
class QPushButton;
class QGridLayout;
class entrywindow : public QMainWindow

{
     Q_OBJECT

public:
    entrywindow();

public slots:
    void buttonplayf();
    void buttonhelpf();
    void buttonnewf();
    void buttoneditf();
    void buttondelf();
    void updateMenus();
    void programclose();
    void settingsshow();
    void aboutdoomrunner ();
	void appendTextBox();
	void doomenginefinished ();

private:
    QListWidget *gameselect;
    QLabel *gamenotes;
    QGraphicsView *gameimage;
    QGraphicsScene *loadimage;
    QSpacerItem *buttonspacer;
    QSpacerItem *notesspacer;
    QPushButton *buttonplay;
    QPushButton *buttonhelp;
    QPushButton *buttonnew;
    QPushButton *buttonedit;
    QPushButton *buttondel;
    QPushButton *buttonquit;
};

class StringList : public QStringList

{

public:
	operator QString() const { return this -> join ( " " ); }
};
#endif
