/*-----------------------------------------------------------------------+
| Doom Runner: A cross-platform GUI frontend for Doom.                   |
| Copyright (C) 2011 Nick Virag                                          |
+------------------------------------------------------------------------+
| This program is free software: you can redistribute it and/or modify   |
| it under the terms of the GNU General Public License as published by   |
| the Free Software Foundation, either version 3 of the License, or      |
| any later version.                                                     |
+------------------------------------------------------------------------+
| This program is distributed in the hope that it will be useful,        |
| but WITHOUT ANY WARRANTY; without even the implied warranty of         |
| MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the          |
| GNU General Public License for more details.                           |
+------------------------------------------------------------------------+
| You should have received a copy of the GNU General Public License      |
| along with this program.  If not, see <http://www.gnu.org/licenses/>.  |
+------------------------------------------------------------------------+
| Contact Nick Virag at: <nick@win31.net>, <support@retronuggetdev.com>, |
| or <nickel516@gmail.com>.                                              |
+-----------------------------------------------------------------------*/
#if defined(Q_OS_MAC)
    if (pluginsDir.dirName() == "MacOS") {
        pluginsDir.cdUp();
    }
#endif
#include <QtGui/QApplication>
#include <QtGui/QtGui>
#include <string>
#include <fstream>
#include <iostream>
#include <sstream>
#include "doomrunner.h"
#include "main.h"
#include "addnewfile.h"
string startdir, titletransfer, notestransfer, imagetransfer, newgamename, newgamenotes, newopenfile, newiwadlistitem, preadf[90];

int itemselect, selecteditem, readwidth, readheight, currentselecteditem, windowstyle, ostoggle2, toolbartoggleint, sliderint, sliderspeedint, selectedtab, windowx, windowy, glestoggle, globaltoggle, askruntoggle;

int displayswitch = 1;

string currentmenuitem = "0";

int currentselected = 0;

bool toolbartoogle;

bool restoggle = false;

void interfaceviews( bool toggle ) {
    if ( toggle == true ) {
        int find = startdir.find_last_of( "/\\" );
        startdir = startdir.substr( 0,find );
    }
    else { for ( int clrvar = 0; clrvar == 90; clrvar++ ) { preadf[clrvar] = "end"; } }
    string line;
    int arrayloc = 0;
    int profileloc = 1;
    stringstream numstring1;
    string settingsdir = startdir + "/profiles/profile1.txt";
    bool endtoggle = true;
    while ( endtoggle == true ) {
        if ( settingsdir != startdir + "/profiles/profile1.txt" ) {
            numstring1.str( std::string() );
            numstring1 << profileloc;
            settingsdir = startdir + "/profiles/profile" + numstring1.str() + ".txt";
        }
        ifstream settingsfile;
        settingsfile.open( settingsdir.c_str(),ios::in );
        if (settingsfile.is_open()) {
            string tinput;
            while ( ! settingsfile.eof() ) {
                getline ( settingsfile,line );
                tinput = tinput + "^" + line;
            }
            tinput.erase( 0,1 );
            string::size_type parser = tinput.find_first_of( "^" );
            preadf[arrayloc] = tinput.substr( 0, parser );
            tinput.erase( 0,parser + 1 );
            parser = tinput.find_first_of( "^" );
            arrayloc++;
            preadf[arrayloc] = tinput.substr( 0, parser );
            tinput.erase( 0,parser + 1 );
            parser = tinput.find_first_of( "^" );
            arrayloc++;
            preadf[arrayloc] = tinput.substr( 0, parser );
            profileloc++;
            arrayloc++;
            settingsdir = "";
            if ( profileloc == 30 ) { endtoggle = false; }
            settingsfile.close();
        }
        else { endtoggle = false; }
    }
    preadf[arrayloc] = "end";
}

int main( int argc, char *argv[] ) {
    #if defined( Q_OS_MAC )
        ostoggle2 = 2;
    #elif defined ( Q_OS_WIN )
        ostoggle2 = 1;
    #else
        ostoggle2 = 0;
    #endif
    cout << "Doom Runner 1.0.3 Copyright (C) 2011 Nicholas Virag This program comes with ABSOLUTELY NO WARRANTY; This is free software, and you are welcome to redistribute it under certain conditions; for details see the included \"./gpl-3.0.txt\".\n";
    startdir = argv[0];
	interfaceviews( true );
    string line, styleinput, toolbarstylestring, sliderstring, sliderspeedstring;
    string settingsdir = startdir + "/profiles/profile0.txt";
    ifstream settingsfile;
    settingsfile.open( settingsdir.c_str(),ios::in );
    if (settingsfile.is_open()) {
        string tinput;
        while ( ! settingsfile.eof() ) {
            getline ( settingsfile,line );
            tinput = tinput + "^" + line;
        }
        tinput.erase( 0,1 );
        string::size_type parser = tinput.find_first_of( "^" );
        styleinput = tinput.substr( 0, parser );
        tinput.erase( 0, parser + 1 );
        parser = tinput.find_first_of( "^" );
        toolbarstylestring = tinput.substr( 0, parser );
        tinput.erase( 0, parser + 1 );
        parser = tinput.find_first_of( "^" );
        sliderstring = tinput.substr( 0, parser );
        tinput.erase( 0, parser + 1 );
        parser = tinput.find_first_of( "^" );
        sliderspeedstring = tinput.substr( 0, parser );
        tinput.erase( 0, parser + 1 );
        parser = tinput.find_first_of( "^" );
        glestoggle = atoi ( tinput . substr ( 0 , parser ) . c_str () );
        tinput.erase( 0, parser + 1 );
        parser = tinput.find_first_of( "^" );
        askruntoggle = atoi ( tinput . substr ( 0 , parser ) . c_str () );	
        tinput.erase( 0, parser + 1 );
        parser = tinput.find_first_of( "^" );
        globaltoggle = atoi ( tinput . substr ( 0 , parser ) . c_str () );	
		settingsfile.close();
        if ( toolbarstylestring == "0" ) { windowstyle = 0; }
        if ( toolbarstylestring == "1" ) { windowstyle = 1; }
        if ( toolbarstylestring == "2" ) { windowstyle = 2; }
        if ( toolbarstylestring == "3" ) { windowstyle = 3; }
        if ( toolbarstylestring == "4" ) { windowstyle = 4; }
        if ( toolbarstylestring == "5" ) { windowstyle = 5; }
        if ( styleinput == "0" ) { toolbartoggleint = 0; }
        if ( styleinput == "1" ) { toolbartoggleint = 1; }
        if ( sliderstring == "0" ) { sliderint = 0; }
        if ( sliderstring == "1" ) { sliderint = 1; }
        sliderspeedint = atoi ( sliderspeedstring . c_str () );
    }
    if ( windowstyle == 1 ) { QApplication::setStyle("cleanlooks"); }
    if ( windowstyle == 2 ) { QApplication::setStyle("plastique"); }
    if ( windowstyle == 3 ) { QApplication::setStyle("windows"); }
    if ( windowstyle == 4 ) { QApplication::setStyle("cde"); }
    if ( windowstyle == 5 ) { QApplication::setStyle("motif"); }
    if ( ostoggle2 == 2 ) { cout << "------------------------------\nDoomRunner working in MacOS mode\n"; }
    else if ( ostoggle2 == 1 ) { cout << "------------------------------\nDoomRunner working in Windows mode\n"; }
    else { cout << "------------------------------\nDoomRunner working in Unix/Linux mode.\n"; }
    QApplication app( argc, argv );    
    if ( preadf[0] != "end" ) {
        entrywindow *window = new entrywindow;
        window->show();
    }
    else {
        addnewfile *window2 = new addnewfile;
        window2->show();
    }
    return app.exec();
}
